# this program demonstrates how the univariate (non-robust) regression
# can deal with large data sets. When dealing with larger regressions
# the technique requires 
# 1) Storage of the matrix X (n by p) where p=max num. of possible knots
# By default p is set to 35, but changing the density option can alter this.
# 2) Initial (once only) calculation of the matrix X'X (p by p) and from
# there on, calculations are INDEPENDENT of n.

# generate data.
x_rnorm(5000)
y_sin(2*pi*x)+rnorm(5000,0,3)

# model the data as y = f(x) + e
junk_br(xs=x,y=y)

# plot the data.
par(mfrow=c(2,1))
plot(x,y,pch=".")

#plot the function estimate.
lines(junk$xplot,junk$yplot+junk$beta[1])

#plot the true function.
lines(junk$xplot,sin(2*pi*junk$xplot),lty=2)

# do this again, but without the data on the plot.
plot(junk$xplot,junk$yplot+junk$beta[1],type="l")
lines(junk$xplot,sin(2*pi*junk$xplot),lty=2)
